
/******************************************************
  Included Libraries
 *******************************************************/

#ifdef ESP32
#include <WiFi.h>
#include <HTTPClient.h>
#else
#include <ESP8266WiFi.h>
#include <ESP8266HTTPClient.h>
#include <WiFiClient.h>
#endif


/******************************************************
  Declare all Information for Wifi / Server 
  
  ! YOU NEED TO CHANGE THIS INFORMATIONS 0!
  
 *******************************************************/

const char* ssid     = "Put your WLAN Name here";
const char* password = "Put your WLAN Password here";

// This ist the dataline, we send to the server - you need a http for this. https perhaps won't work
const char* serverName = "http://yourWebdomain.com/yourfolder/.../posttomydatabase.php";


String sensor = "sensor"; //Sring for sensor name
String place = "location"; //String for sensor location
int noise = 0; //noise variable


/******************************************************
   Declare Sensor Pins and Counter
*******************************************************/


/*** Sensor ***/ 

int sensor_right_pin = 14; //Right Photoelectric Barrier on GPIO14 (Input D5) on ESP
int sensor_left_pin = 12; //Left Photoelectric Barrier on GPIO12 (Input D6)

int sensor_right_state = 0; 
int sensor_left_state  = 0;

int sensor_right_state_last = -1; 
int sensor_left_state_last  = -1;

bool bWalkIn = false; //true or false - statement for Walkin / Walkout
bool bWalkOut = false;

unsigned long tm; //Speicherfunktion without negativ numbers


/*** Counter ***/

int in_counter = 0; // (counter++)
int out_counter = 0; //(counter--)

int counter = 0; //MAIN COUNTER  in_counter - out_counter
int counter_last_state = -1;



/*** Other Outputs / Inputs ***/

const int MIC = A0; //the microphone amplifier is connected to pin A0

const int ledPin = D8; //we route a led-light to the outside of the box to indicate the sucessfull wifi connection

int j = 0;




/******************************************************
   Setup for Wifi and Pins
*******************************************/

void setup() {
 Serial.begin(9600);
 
 pinMode( sensor_right_pin, INPUT);
 pinMode( sensor_left_pin , INPUT);
 pinMode(MIC, INPUT);
 pinMode(ledPin, OUTPUT);
 
 //Connect to WIFI
 WifiInitialize();

//Reset for average noise value on startup
averageReset();
 
 }



/******************************************************
  Main loop function
*******************************************************/

 void loop() {

     sensor_right_state = digitalRead( sensor_right_pin );
     sensor_left_state =  digitalRead( sensor_left_pin );

     checkWalkIn(); 
     checkWalkOUT();
     
     counter = in_counter - out_counter; //counting all people and put them to counter


      // No negative number of people
      
     if (counter < 0) {
      counter = 0;
      in_counter = 0; 
      out_counter = 0; 
      counter_last_state = 0;
      
      };


      readNoise(); // enviromental noise


       /*********************************************************************/
      /*****************ONLY  TESTING & DEBUGGING ON WEBPAGE **************/
     // counter = random(0,100);
     // noise = random(20, 180);
     // delay (8000);
      /*****************ONLY  TESTING & DEBUGGING ON WEBPAGE ****************/
      /*********************************************************************/


 
      // Make it "realtime" - only executes when counter is triggered and uploads to web
      
      if (counter > counter_last_state) {
         counter_last_state = counter;
         SendDatatoServer(sensor, place, counter, noise);
         
      };


      if (counter < counter_last_state){
         counter_last_state = counter;
         SendDatatoServer(sensor, place, counter, noise);
         
      };

    
     // Shows counter // noise in serial monitor
     Serial.println(counter);
     Serial.println(noise);

    
  };

   
