                         
/******************************************************
This part connects to a local Wifi and sends measured data 
to a PHP script on the webserver where it is stored with a timestamp to
a MySQL database. Our PHP-Script will then read the database and creates a json.-File.
*******************************************************/


/******************************************************
 Send dataline to server
 *******************************************************/

void SendDatatoServer(String sensor, String place, int counter, int noise) {

    
    if (WiFi.status() == WL_CONNECTED) {
    
        Serial.begin(9600);

        digitalWrite(ledPin,HIGH);
        delay (100);
        digitalWrite(ledPin,LOW);

        HTTPClient http;

        //Build call string:
        String dataline = serverName;
    
        dataline += "?source=" + String(sensor);
        dataline += "&place=" + String(place);
        dataline += "&counter=" + String(counter);
        dataline += "&noise=" + String(noise);

        //Serial.print("dataline: ");
        //Serial.print (dataline);

        bool httpResult = http.begin(dataline);
        Serial.println ("<br> Send to web executed");
        Serial.println (counter);

            if (!httpResult){
              //Serial.println("Invalid HTTP request: ");
              Serial.println(dataline); 
            } else {
               int httpCode = http.GET();
               
                if (httpCode > 0) { 
                      // Request has been made }
                      Serial.printf(" //// HTTP status: %d Message: ", httpCode);
                      String payload = http.getString();
                      Serial.println("<br>Sent dataline:");
                      Serial.println(dataline); 
                      Serial.println("<br>Sent payload:");
                      Serial.println(payload);
                     } else { 
                      
                     // Request could not be made
                     }
                    //Serial.printf("HTTP request failed. Error: %s\r\n", http.errorToString(httpCode).c_str());
                     };
            http.end();
            
    } else {
      Serial.println("WiFi Disconnected");

       digitalWrite(ledPin,HIGH);
      delay(100);
      digitalWrite(ledPin,LOW);
      delay(400);
      digitalWrite(ledPin,HIGH);
      delay(900);
      digitalWrite(ledPin,LOW);

          }

    };




/******************************************************
 Initialises the wifi-connection
 *******************************************************/

void WifiInitialize () {
  
    digitalWrite(ledPin,HIGH);
    
    Serial.println("Starting setup");
    Serial.print("Scan start ... ");
    delay(400);
    int n = WiFi.scanNetworks();
    Serial.print(n);
    Serial.println(" network(s) found");

    for (int i = 0; i < n; i++) {
      Serial.println(WiFi.SSID(i));
    };

    Serial.println();
    Serial.println("++++++ ESTABLISHING WIFI CONNECTION  ++++++++");
    Serial.println();

    WiFi.disconnect(true);
    WiFi.begin(ssid, password);
    delay(200);

    Serial.println("CONNECTING to");
    Serial.println(ssid);
    Serial.println(password);
    Serial.println();

    while (WiFi.status() != WL_CONNECTED) {
     
      delay(500);
      Serial.print(".");
  
    }

    Serial.println("");
    Serial.print("Connected to WiFi network with IP Address: ");
    Serial.println(WiFi.localIP());
    
    digitalWrite(ledPin,LOW);
 };
 
